#! /usr/bin/env python3
# -*- coding: utf-8 -*-
import os
import socket
from multiprocessing import Process

from time import sleep, time
from select import select
from argparse import ArgumentParser
from threading import Thread
from contextlib import nullcontext

from serial import Serial, SerialException


class RateLimit:
    """ A helper for making sure a code path is not executed too often within a timeframe. """

    def __init__(self):
        self._lastTime = None

    def limit(self, seconds):
        """
        Potentially wait until the given time in seconds have passed since the last time this function was called.

        :param seconds: Seconds since the last time this function was called.
        """
        if self._lastTime is not None:
            timeLeft = seconds - (time() - self._lastTime)
            if timeLeft > 0:
                sleep(timeLeft)
        self._lastTime = time()


class FileSerial:
    """
    An object imitating a serial interface that reads from a file when read from and prints to stdout when written to.
    """

    def __init__(self, filePath: str):
        """
        Initiate a new file backed serial.

        :param filePath: The path to the backing file, which will be read from.
        """
        self._path = filePath
        self._size = 0

    def open(self):
        """ Open the serial port. """
        with open(self._path, 'rb') as f:
            f.seek(os.SEEK_END)
            self._size = f.tell()

    def close(self):
        """ Close the serial port """

    def inWaiting(self):
        """ How many bytes are available to read. """
        return self._size

    def read(self, _: int) -> bytes:
        """ Read from the serial port. """
        sleep(20)  # Add some delay to avoid flooding the database
        with open(self._path, 'rb') as file:
            return file.read()

    @staticmethod
    def write(buffer: bytes):
        """ Write to the serial port. """
        print(buffer)


class StoppableThread(Thread):
    """ A thread that can be signaled to stop. """
    def __init__(self, target, *_args, **_kwargs):
        super().__init__(*_args, **_kwargs, target=self._callTarget)
        self._originalTarget = target
        self._stopped = False

    def isStopped(self) -> bool:
        """
        :return: Whether the thread was signaled to stop.
        """
        return self._stopped

    def stop(self):
        """ Signal this thread to stop. """
        self._stopped = True
        self.join()

    def _callTarget(self, *args, **kwargs):
        self._originalTarget(self, *args, **kwargs)


class SerialProxy:
    """
    A proxy which forwards the telemetry received via the serial port to a connected the docker
    container and forwards the telecommands generated by the container to the serial port.
    """

    def __init__(self, serialPort, baudrate, host='127.0.0.1', port=50000, fileSource=None, recordDir=None):
        """
        Initialize the proxy.

        :param serialPort: The port of the serial connection on the computer.
        :param baudrate: The baudrate to use for the serial connection.
        :param host: The host to listen on for connection attempts of the docker container.
        :param port: The port to listen on for connection attempts of the docker container.
        :param fileSource: Optional filepath, which takes precedence over the serial and baudrate.
                           The file will be used as a read source while output will go to stdout.
        :param recordDir: Optional path to directory to record the data to.
        """
        super().__init__()
        if fileSource is not None:
            self._connection = FileSerial(fileSource)
        else:
            self._connection = Serial(baudrate=baudrate, timeout=1)
            try:
                self._connection.set_buffer_size(rx_size=640000)
            except AttributeError:
                pass  # Not all systems support setting the buffer size
            self._connection.setPort(serialPort)
        self._recordingDir = recordDir if recordDir is not None else None
        if recordDir is not None:
            os.makedirs(recordDir, exist_ok=True)
        self._connection.open()
        print('[Info ] Serial connected')
        self._serverAddress = (host, port)
        self._running = True

    def run(self):
        """ Continuously wait for a connection and then proxy the serial connection to it. """
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as serverSocket, \
                nullcontext() if self._recordingDir is None else open(os.path.join(
                    self._recordingDir, 'telecommands.bin'), 'ab') as recordFile:
            serverSocket.bind(self._serverAddress)
            serverSocket.listen()
            serverSocket.settimeout(5)
            reconnectRateLimit = RateLimit()
            try:
                while self._running:
                    print('[Info ] Waiting for connection...')
                    try:
                        clientConnection, clientAddress = serverSocket.accept()
                    except socket.timeout:
                        continue
                    except KeyboardInterrupt:
                        self._running = False
                        break
                    with clientConnection:
                        clientConnection.setblocking(False)
                        print('[Info ] Connected by', clientAddress)
                        serialToClientThread = StoppableThread(target=self._forwardSerialToClientSocket,
                                                               args=(clientConnection, ))
                        serialToClientThread.start()
                        try:
                            try:
                                while self._running:
                                    readyToRead, _, _ = select([clientConnection], [], [], 2)
                                    if readyToRead:
                                        data = clientConnection.recv(4096)
                                        if not data:
                                            print('[Info ] Socket disconnected')
                                            break
                                        self._connection.write(data)
                                        if recordFile:
                                            recordFile.write(data)
                            except IOError as error:
                                if self._running:
                                    print(f'[Error] {error}')
                                    reconnectRateLimit.limit(1)
                        except KeyboardInterrupt:
                            print('[Info ] Exiting...')
                            self._running = False
                    clientConnection.close()
                    serialToClientThread.stop()
            finally:
                self._running = False
        self._connection.close()

    def _forwardSerialToClientSocket(self, selfThread, clientSocket):
        """
        Forward data from the serial connection to the client socket.

        :param clientSocket: The socket to forward data to.
        """
        try:
            with nullcontext() if self._recordingDir is None else open(
                    os.path.join(self._recordingDir, 'telemetry.bin'), 'ab') as recordFile:
                reconnectRateLimit = RateLimit()
                while self._running and not selfThread.isStopped():
                    try:
                        buffer = self._connection.read(self._connection.inWaiting() or 1)
                        if buffer:
                            clientSocket.sendall(buffer)
                            if recordFile is not None:
                                recordFile.write(buffer)
                    except SerialException as error:
                        print(f'[Error] Serial port unavailable, trying to reconnect: {error}')
                        self._running = False
                    except IOError as error:
                        if self._running:
                            print(f'[Error] {error}')
                            reconnectRateLimit.limit(1)
        except KeyboardInterrupt:
            print('[Info ] Exiting...')
            self._running = False
        clientSocket.close()


def runProxy(serial, baudrate, host, port, file, record):
    """
    Run the serial to Docker proxy.

    :param serial: The port of the serial connection on the computer.
    :param baudrate: The baudrate to use for the serial connection.
    :param host: The host to listen on for connection attempts of the docker container.
    :param port: The port to listen on for connection attempts of the docker container.
    :param file: Optional filepath, which takes precedence over the serial and baudrate.
                 The file will be used as a read source while output will go to stdout.
    :param record: Optional path to directory to record the data to.
    """
    try:
        SerialProxy(serial, baudrate, host, port, file, record).run()
    except KeyboardInterrupt:
        pass
    except Exception as error:
        print(f'[Error] {error}')


def main():
    """
    Provide a socket endpoint for the Docker ground station to connect to.
    Forward the telemetry received via the serial port to the docker container
    and forward the telecommands generated by the container to the serial port.
    """
    parser = ArgumentParser(description='Bidirectional communication proxy between Aster '
                                        'serial connection and the docker container.')
    connectionArgs = parser.add_mutually_exclusive_group(required=True)
    connectionArgs.add_argument('-s', '--serial', help='The serial port that the ASTER project is connected to.')
    connectionArgs.add_argument('-f', '--file',
                                help='If given, the serial and baudrate will be ignored, instead the file will be used '
                                     'as a read source and output will go to stdout.')
    parser.add_argument('-b', '--baudrate', help='The baudrate to use for the serial connection.',
                        type=int, default=38400, required=False)
    parser.add_argument('--host', default='127.0.0.1',
                        help='The host to listen for connections from the docker container from.')
    parser.add_argument('-p', '--port', default=50000, type=int, help='The port of the proxy server.')
    parser.add_argument('-r', '--record', help='Optional directory to record the incoming data into.')

    arguments = parser.parse_args()
    rateLimit = RateLimit()
    try:
        while True:
            process = Process(target=runProxy, args=(arguments.serial, arguments.baudrate, arguments.host,
                                                     arguments.port, arguments.file, arguments.record))
            process.start()
            process.join()
            rateLimit.limit(1)
    except KeyboardInterrupt:
        pass


if __name__ == '__main__':
    main()
